net.sf.saxon.type

## Interface ItemType

- All Superinterfaces:
    Serializable
  All Known Subinterfaces:
    AtomicType, FunctionItemType, PlainType, UnionType
  All Known Implementing Classes:
    AnyChildNodeTest, AnyFunctionType, AnyItemType, AnyNodeTest, BuiltInAtomicType, CombinedNodeTest, ContentTypeTest, DocumentNodeTest, EmptySequenceTest, ErrorType, ExternalObjectType, LocalNameTest, MapType, NamespaceTest, NameTest, NodeKindTest, NodeTest, SchemaAttributeTest, SchemaElementTest, SpecificFunctionType, UserAtomicType, UserUnionType

      public interface ItemType
      extends Serializable

  ItemType is an interface that allows testing of whether an Item conforms to an expected type. ItemType represents the types in the type hierarchy in the XPath model, as distinct from the schema model: an item type is either item() (matches everything), a node type (matches nodes), an atomic type (matches atomic values), or empty() (matches nothing). Atomic types, represented by the class AtomicType, are also instances of SimpleType in the schema type hierarchy. Node Types, represented by the class NodeTest, are also Patterns as used in XSLT.

  Saxon assumes that apart from `AnyItemType` (which corresponds to `item() and matches anything), every ItemType will be either an `AtomicType`, a `NodeTest`, or a `FunctionItemType`. User-defined implementations of ItemType must therefore extend one of those three classes/interfaces.`

  See Also:
    `AtomicType`, `NodeTest`, `FunctionItemType`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PlainType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized
    `double` | `getDefaultPriority()` Determine the default priority of this item type when used on its own as a Pattern
    `ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` Get the primitive type corresponding to this item type.
    `ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
    `boolean` | `isAtomicType()` Determine whether this item type is an atomic type
    `boolean` | `isAtomizable()` Ask whether values of this type are atomizable
    `boolean` | `isPlainType()` Determine whether this item type is a plain type (that is, whether it can ONLY match atomic values)
    `boolean` | `matches(Item item, XPathContext context)` Test whether a given item conforms to this type
    `boolean` | `matchesItem(Item item, boolean allowURIPromotion, Configuration config)` Test whether a given item conforms to this type
    `void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

- - ### Method Detail

    - #### isAtomicType

          boolean isAtomicType()

      Determine whether this item type is an atomic type
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof

    - #### isPlainType

          boolean isPlainType()

      Determine whether this item type is a plain type (that is, whether it can ONLY match atomic values)
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof, or a "plain" union type (that is, unions of atomic types that impose no further restrictions)

    - #### matches

          boolean matches(Item item,
                        XPathContext context)

      Test whether a given item conforms to this type
      Parameters:
        `item` - The item to be tested
        `context` - the XPath dynamic evaluation context
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### matchesItem

          boolean matchesItem(Item item,
                            boolean allowURIPromotion,
                            Configuration config)

      Test whether a given item conforms to this type
      Parameters:
        `item` - The item to be tested
        `allowURIPromotion` - if a URI value is to be treated as a string
        `config` - the Saxon configuration
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### getSuperType

          ItemType getSuperType(TypeHierarchy th)

      Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

      In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the supertype, or null if this type is item()

    - #### getPrimitiveItemType

          ItemType getPrimitiveItemType()

      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue and union types it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that integer, xs:dayTimeDuration, and xs:yearMonthDuration are considered to be primitive types.
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          int getPrimitiveType()

      Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is BuiltInAtomicType.ANY_ATOMIC. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Returns:
        the integer fingerprint of the corresponding primitive type

    - #### getDefaultPriority

          double getDefaultPriority()

      Determine the default priority of this item type when used on its own as a Pattern
      Returns:
        the default priority

    - #### getAtomizedItemType

          PlainType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          boolean isAtomizable()

      Ask whether values of this type are atomizable
      Returns:
        true unless it is known that these items will be elements with element-only content, or function items, in which case return false

    - #### visitNamedSchemaComponents

          void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                          throws XPathException

      Visit all the schema components used in this ItemType definition
      Parameters:
        `visitor` - the visitor class to be called when each component is visited
      Throws:
        `XPathException` - if an error occurs

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.